.TH DC3ARCHIVE 1 "05 Mar 1995" "Vendor Archives" "Vendor specific archive utilities"
.SH NAME
dc3archive \- Vendor specific archive utilities
.SH SYNOPSIS
.SS "Generic archive tools ..."
.LP
\ 
.HP 10
.B ex9t
.I devicename
.HP 10
.B ls9t
.I devicename
.SS "GE 9800 Nine-track tape archive tools ..."
.LP
\ 
.HP 10
.B ge98ex9t
.I devicename
.HP 10
.B ge98gzip
.HP 10
.B ge98ls9t
[
.B \-v|\-b|\-i|\-t
] <
.I tapedirfilename
.HP 10
.B ge98vf9t
.I tapedirfilenames
.SS "GE Genesis DAT archive tools ..."
.LP
\ 
.HP 10
.B gndhier
.I filenames
.HP 10
.B gndtopgm
<
.I genesisdatfile
>
.I pgmfile
.SS "Philips Gyroscan S15 archive tools ..."
.LP
\ 
.HP 10
.B s15dunmr
<
.I nnnn.NMR
>
.I nnnn.NMR.dumped
.HP 10
.B s15ex9t
.I /dev/rstn
.HP 10
.B s15exall
.I series
.I outprefix
.HP 10
.B s15exnmr
<
.I nnnn.NMR.dumped
>
.I commandlineargs
.HP 10
.B s15exrec
.I resolution
.I number
<
.I nnnn.REC
>
.I nnnn.NMR.dumped
.HP 10
.B s15todc
.I series
.I outprefix
.SH DESCRIPTION
.LP
This man page briefly describes the utility programs available for extracting 
image data and attributes from various vendor's proprietary archive formats. The common features and options are described here.
.LP
For more information about each specific utility, see the individual man pages listed under the "See Also" section.
.LP
Described elsewhere are programs for converting from various vendor's proprietary image formats, both to DICOM offline files (see the man page dc3convert.1) as well as primitive file types (see the man page dc3simple.1), utilities for manipulating DICOM offline files (see the man page dc3intro.1),and various miscellaneous utilities related to manipulation of medical images (see the man page dc3misc.1).
.SS "Generic archive tools ..."
.LP
\ 
.LP
.B ex9t
extracts all the available files from the specified tape device.
.LP
.B ls9t
lists all the available files from the specified tape device.
.SS "GE 9800 Nine-track tape archive tools ..."
.LP
\ 
.LP
.B ge98ex9t
extracts entire tape contents into a hierarchical directory of the form id/exam/prs/type/image.
.LP
.B ge98gzip
executes a command (usually gzip) over a hierarchical directory of the form id/exam/prs/type/image.
.LP
.B ge98ls9t
lists the contents of the GE 9800 image tape directory
.LP
.B ge98vf9t
verifies all the images in the tape directories are present.
.LP
.SS "GE Genesis DAT archive tools ..."
.LP
\ 
.LP
.B gndhier
moves files from ex9t into a hierarchical directory of the form study/series/type/image.gnd.
.LP
.B gndtopgm
converts a Genesis DAT image into a pgm file.
.LP
.SS "Philips Gyroscan S15 archive tools ..."
.LP
\ 
.LP
.B s15dunmr
dumps the contents of a Philips Gyroscan S15 .NMR file. This file describes the parameters of a sequence.
.LP
.B s15ex9t
extracts the entire contents of a Philips Gyroscan S15 Vax VMS (ANSI format) tape.
.LP
.B s15exall
extracts all the images from a .REC file into raw files.
.LP
.B s15exnmr
extracts parameters from an .NMR file to command line parameters for dc3cp.
.LP
.B s15exrec
extracts a single image from a .REC file into a raw file.
.LP
.B s15exall
extracts all the images from a .REC file into DICOM files.
.LP
.SH OPTIONS
.LP
\ 
.SH ENVIRONMENT
.LP
\ 
.SH EXAMPLES
.LP
\ 
.SH FILES
.LP
\ 
.SH SEE ALSO
.BR dc3archive(1) ,
.BR dc3convert(1) ,
.BR dc3intro(1) ,
.BR dc3intro(3) ,
.BR dc3intro(5) ,
.BR dc3misc(1) ,
.BR dc3simple(1) ,
.BR ex9t(1) ,
.BR ls9t(1)
.SH AUTHOR
Copyright (C) 1993,1994,1995. David A. Clunie. All rights reserved.
.SH BUGS
