/* ge98man1.h 0.12 95/09/18 Copyright (C) 1993,1994,1995. David A. Clunie. All rights reserved. */

	{
		// AccessionNumber = ""

		DC3Tag tag (DC3AccessionNumber_GROUP,
			    DC3AccessionNumber_ELEMENT);
		char *str = "";
		DC3ShortString *attribute =
			new DC3ShortString(tag,strlen(str),str);
		list.insert(attribute);
	}
	{
		// PatientSex = ""

		DC3Tag tag (DC3PatientSex_GROUP,
			    DC3PatientSex_ELEMENT);
		char *str = "";
		DC3CodeString *attribute =
			new DC3CodeString(tag,strlen(str),str);
		list.insert(attribute);
	}
	{
		// PatientBirthDate = ""

		DC3Tag tag (DC3PatientBirthDate_GROUP,
			    DC3PatientBirthDate_ELEMENT);
		char *str = "";
		DC3DateString *attribute =
			new DC3DateString(tag,strlen(str),str);
		list.insert(attribute);
	}
	{	// SOPClassUID

		DC3Tag tag (DC3SOPClassUID_GROUP,
			    DC3SOPClassUID_ELEMENT);
		char *str = DC3CTImageStorageSOPClass;
		DC3UIString *attribute =
			new DC3UIString(tag,strlen(str),str);
		list.insert(attribute);
	}
	{	// SOPInstanceUID

		DC3GeneratedSOPInstanceUID uid
			(stamp,CT98_StudyNumber.toUS(),
			       CT98_SeriesNumber.toUS(),
			       CT98_ImageNumber.toUS());
		DC3Tag tag (DC3SOPInstanceUID_GROUP,
			    DC3SOPInstanceUID_ELEMENT);
		char *str = uid.GetUID();
		DC3UIString *attribute =
			new DC3UIString(tag,strlen(str),str);
		list.insert(attribute);
	}
	{	// StudyInstanceUID

		DC3GeneratedStudyInstanceUID uid
			 (stamp,CT98_StudyNumber.toUS());
		DC3Tag tag (DC3StudyInstanceUID_GROUP,
			    DC3StudyInstanceUID_ELEMENT);
		char *str = uid.GetUID();
		DC3UIString *attribute =
			new DC3UIString(tag,strlen(str),str);
		list.insert(attribute);
	}
	{	// SeriesInstanceUID

		DC3GeneratedSeriesInstanceUID uid
			(stamp,CT98_StudyNumber.toUS(),
			       CT98_SeriesNumber.toUS());
		DC3Tag tag (DC3SeriesInstanceUID_GROUP,
			    DC3SeriesInstanceUID_ELEMENT);
		char *str = uid.GetUID();
		DC3UIString *attribute =
			new DC3UIString(tag,strlen(str),str);
		list.insert(attribute);
	}
	{	// FrameOfReferenceUID

		DC3GeneratedFrameOfReferenceUID uid
			(stamp,CT98_StudyNumber.toUS(),
			       CT98_SeriesNumber.toUS());
		DC3Tag tag (DC3FrameOfReferenceUID_GROUP,
			    DC3FrameOfReferenceUID_ELEMENT);
		char *str = uid.GetUID();
		DC3UIString *attribute =
			new DC3UIString(tag,strlen(str),str);
		list.insert(attribute);
	}
	{
		// PositionReferenceIndicator

		DC3Tag tag (DC3PositionReferenceIndicator_GROUP,
			    DC3PositionReferenceIndicator_ELEMENT);
		char *str = CT98_PositionReference.toLO();
		DC3LongString *attribute =
			new DC3LongString(tag,strlen(str),str);
		list.insert(attribute);
	}
	{
		// Trying to derive Image Plane Module ...

		char *hfff,*ap;

		// GE 9800 plane definitions are unknown:
		// ? units of X,Y center
		// ? direction of table position
		// assume Left Ant Superior +ve (for no really good reason)

		// DICOM plane definitions are:
		// - Left Pos Superior +ve

		// Determine the plane of the image ...
		// There is really no valid way to do this for other
		// than Prospective & Scout views, so presume axial

		ImagePlanePlane plane;

		// Determine the "machine" plane of the image ...

		switch (CT98_FileType.toUS()) {
			case 1:		// Prospective
					plane=Axial;
					break;

			case 2:		// Scout - use tube azimuth later
					// 0 degrees is AP Scout
					plane=Coronal;
		// this is theoretically ok, but 9800 seems to rotate
		// the lateral scout to F/P rather than A/F :(
		// need to do some tests to see in which cases this happens
					break;

			case 3:		// Retrospective
			case 4:		// Segmented
			case 5:		// Screensave
			case 6:		// Plot
			default:	// :(
					plane=Axial;
					break;
		}

		ImagePlaneHeadFeet orientation;

		switch (CT98_PatientOrientation.toUS()) {
			case 1:
					hfff="HF";
					orientation=HeadFirst;
					break;
			case 2:
					hfff="FF";
					orientation=FeetFirst;
					break;
			default:	hfff="";		// :(
					orientation=HeadFirst;
					break;
		}

		ImagePlanePosition position;

		switch (CT98_APPatientOrientation.toUS()) {
			case 1:
					ap="P";
					position=Prone;
					break;
			case 2:
					ap="S";
					position=Supine;
					break;
			case 3:
					ap="DL";
					position=LeftLateralDecubitus;
					break;
			case 4:
					ap="DR";
					position=RightLateralDecubitus;
					break;
			default:	ap="";			// :(
					position=Supine;
					break;
		}

		double xscanfov;
		double yscanfov;

		if (CT98_FileType.toUS() == 2) {	// Scout
			// Could use CT98_ViewsPerScan.toUS() * pixsize ...

			yscanfov = CT98_ScoutEndLocation.todouble()
				  -CT98_SlicePosition.todouble();
			if (yscanfov < 0) yscanfov=-yscanfov;

			// Could use CT98_ReconPixelSize for pixsize ...
			// Could use CT98_ViewSpacing    for pixsize ...
			// but calculating it is more accurate

			double pixsize = yscanfov/
					 (double)CT98_ViewsPerScan.toUS();

			xscanfov = (double)CT98_DetectorsPerView.toUS()
				 * pixsize;
		}
		else {
			// These may actually different, but the image
			// is always square, so select the maximum,
			// otherwise the mag/recon scaling will fail

			xscanfov = CT98_XDiameter.todouble();
			yscanfov = CT98_YDiameter.todouble();
			if (xscanfov > yscanfov) yscanfov=xscanfov;
			if (yscanfov > xscanfov) xscanfov=yscanfov;
		}

		double scanfov = (xscanfov > yscanfov) ? xscanfov : yscanfov;

		double xreconfov;
		double yreconfov;

		if (CT98_FileType.toUS() == 2) {	// Scout
			xreconfov = xscanfov;
			yreconfov = xscanfov;
		}
		else {
			xreconfov = CT98_ReconXDiameter.todouble();
			yreconfov = CT98_ReconYDiameter.todouble();
		}

		double reconfov = (xreconfov > yreconfov)
				 ? xreconfov : yreconfov;

		// Make a model of the image plane ...

		ImagePlane imageplane(plane,xscanfov,yscanfov,
			orientation,position);

		// If scout, rotate into the correct plane ...

		// Rotation is CCW around Z
		// eg. Right Lateral is +90 degrees

		if (CT98_FileType.toUS() == 2) {	// Scout 
			imageplane.MachinePlane::angle(
				HeadFeet,(double)CT98_TubeAzimuth.toSS());
		}

		// While we are in the "display" or "gantry plane ...
		// (before angulation) 

		// Apply any transformations specified in the
		// display/gantry plane, such as magnification and
		// reconstruction target offsets ...

		// Assume that offsets are machine rather than body relative

		// Could use reconfov/scanfov ... same effect ...

		double reconfac	= CT98_ReconMagFactor.todouble();
		double reconch	= CT98_ReconXCenter.todouble();
		double reconcv	= CT98_ReconYCenter.todouble();

		if (reconfac > .00001) {	// ie. not zero
			imageplane.MachinePlane::scale(1.0/reconfac);

			imageplane.MachinePlane::shift(
				Vector3D(reconch,-reconcv,0));
		}

		double magfac	= CT98_MagFactor.todouble();
		double magch	= CT98_XCenter.todouble();
		double magcv	= CT98_YCenter.todouble();

		if (magfac > .00001) {	// ie. not zero
			imageplane.MachinePlane::scale(1.0/magfac);

			imageplane.MachinePlane::shift(
				Vector3D(magch,-magcv,0));
		}

		// CT9800 -ve is top towards table
		// Z is +ve into gantry, but X is +ve left, so leave sign alone

		double gantrydetectortilt=CT98_GantryAngle.todouble();

		imageplane.MachinePlane::angle(LeftRight,gantrydetectortilt);

		// Account for physical offsets after angulation ...
		// CT9800 SlicePosition is positive into gantry

		// For scouts SlicePosition is start position not center

		{
			double zoffset;

			if (CT98_FileType.toUS() == 2) {	// Scout
				zoffset=(CT98_ScoutEndLocation.todouble()
				        +CT98_SlicePosition.todouble())/2;
			}
			else {
				zoffset=CT98_SlicePosition.todouble();
			}
			imageplane.MachinePlane::shift(Vector3D(0,0,zoffset));
		}

		// Now build the DICOM attributes ...

		{
			// PatientPosition

			char str[10];	// Enough for longest combination !
			ostrstream ost(str,10);
			ost << hfff << ap << '\0';
			DC3Tag tag (DC3PatientPosition_GROUP,
			    DC3PatientPosition_ELEMENT);
			DC3CodeString *attribute =
				new DC3CodeString(tag,strlen(str),str);
			list.insert(attribute);
		}
		{
			// ImagePositionPatient

			char str[60];	// Enough for longest combination !
			ostrstream ost(str,60);

			ost << dec << setiosflags(ios::fixed)
			    << setiosflags(ios::showpoint) << setprecision(6)
			    << imageplane.PatientPlane::getTLHC().getX()
			    << "\\"
			    << imageplane.PatientPlane::getTLHC().getY()
			    << "\\"
			    << imageplane.PatientPlane::getTLHC().getZ()
			    << ends;

			DC3Tag tag (DC3ImagePositionPatient_GROUP,
			    DC3ImagePositionPatient_ELEMENT);
			DC3DecimalString *attribute =
				new DC3DecimalString(tag,strlen(str),str);
			list.insert(attribute);
		}
		{
			// ImageOrientationPatient

			char str[60];	// Enough for longest combination !
			ostrstream ost(str,60);

			ost << dec << setiosflags(ios::fixed)
			    << setiosflags(ios::showpoint) << setprecision(6)
			    << imageplane.PatientPlane::getRowVector().getX()
			    << "\\"
			    << imageplane.PatientPlane::getRowVector().getY()
			    << "\\"
			    << imageplane.PatientPlane::getRowVector().getZ()
			    << "\\"
			    << imageplane.PatientPlane::getColVector().getX()
			    << "\\"
			    << imageplane.PatientPlane::getColVector().getY()
			    << "\\"
			    << imageplane.PatientPlane::getColVector().getZ()
			    << ends;

			DC3Tag tag (DC3ImageOrientationPatient_GROUP,
			    DC3ImageOrientationPatient_ELEMENT);
			DC3DecimalString *attribute =
				new DC3DecimalString(tag,strlen(str),str);
			list.insert(attribute);
		}
		{
			// ImagePosition

			char str[60];	// Enough for longest combination !
			ostrstream ost(str,60);

			ost << dec << setiosflags(ios::fixed)
			    << setiosflags(ios::showpoint) << setprecision(6)
			    << imageplane.MachinePlane::getTLHC().getX()
			    << "\\"
			    << imageplane.MachinePlane::getTLHC().getY()
			    << "\\"
			    << imageplane.MachinePlane::getTLHC().getZ()
			    << ends;

			DC3Tag tag (DC3ImagePosition_GROUP,
			    DC3ImagePosition_ELEMENT);
			DC3DecimalString *attribute =
				new DC3DecimalString(tag,strlen(str),str);
			list.insert(attribute);
		}
		{
			// ImageOrientation

			char str[60];	// Enough for longest combination !
			ostrstream ost(str,60);

			ost << dec << setiosflags(ios::fixed)
			    << setiosflags(ios::showpoint) << setprecision(6)
			    << imageplane.MachinePlane::getRowVector().getX()
			    << "\\"
			    << imageplane.MachinePlane::getRowVector().getY()
			    << "\\"
			    << imageplane.MachinePlane::getRowVector().getZ()
			    << "\\"
			    << imageplane.MachinePlane::getColVector().getX()
			    << "\\"
			    << imageplane.MachinePlane::getColVector().getY()
			    << "\\"
			    << imageplane.MachinePlane::getColVector().getZ()
			    << ends;

			DC3Tag tag (DC3ImageOrientation_GROUP,
			    DC3ImageOrientation_ELEMENT);
			DC3DecimalString *attribute =
				new DC3DecimalString(tag,strlen(str),str);
			list.insert(attribute);
		}
		{
			// PatientOrientation

			char str[10];	// Enough for longest combination !
			ostrstream ost(str,10);

			ost << imageplane.PatientPlane::getRowOrientation()
			    << "\\"
			    << imageplane.PatientPlane::getColOrientation()
			    << ends;

			DC3Tag tag (DC3PatientOrientation_GROUP,
			    DC3PatientOrientation_ELEMENT);
			DC3CodeString *attribute =
				new DC3CodeString(tag,strlen(str),str);
			list.insert(attribute);
		}
		{
			// ReconstructionDiameter

			char str[20];	// should be enough for DG Real !
			ostrstream ost(str,20);
			ost << dec << reconfov << '\0';

			DC3Tag tag (DC3ReconstructionDiameter_GROUP,
				    DC3ReconstructionDiameter_ELEMENT);
			DC3DecimalString *attribute =
				new DC3DecimalString(tag,strlen(str),str);
			list.insert(attribute);
		}
		{
			// DataCollectionDiameter

			char str[20];	// should be enough for DG Real !
			ostrstream ost(str,20);
			ost << dec << scanfov << '\0';

			DC3Tag tag (DC3DataCollectionDiameter_GROUP,
				    DC3DataCollectionDiameter_ELEMENT);
			DC3DecimalString *attribute =
				new DC3DecimalString(tag,strlen(str),str);
			list.insert(attribute);
		}
		{
			// GantryDetectorTilt

			char str[20];	// should be enough for DG Real !
			ostrstream ost(str,20);
			ost << dec << gantrydetectortilt << '\0';

			DC3Tag tag (DC3GantryDetectorTilt_GROUP,
				    DC3GantryDetectorTilt_ELEMENT);
			DC3DecimalString *attribute =
				new DC3DecimalString(tag,strlen(str),str);
			list.insert(attribute);
		}
	}
	{
		// ImageType

		char *value1,*value2,*value3;

		switch (CT98_FileType.toUS()) {
			case 1:		// Prospective
					value1="ORIGINAL";
					value2="PRIMARY";
					value3="AXIAL";
					break;
			case 2:		// Scout
					value1="ORIGINAL";
					value2="PRIMARY";
					value3="LOCALIZER";
					break;
			case 3:		// Retrospective
					value1="DERIVED";
					value2="SECONDARY";
					value3="AXIAL";
					break;
			case 4:		// Segmented
					value1="DERIVED";
					value2="SECONDARY";
					value3="AXIAL";
					break;
			case 5:		// Screensave
					value1="DERIVED";
					value2="SECONDARY";
					value3="AXIAL";
					break;
			case 6:		// Plot
					value1="";
					value2="";
					value3="";
					break;
			default:
					value1="";
					value2="";
					value3="";
					break;
		}

		DC3Tag tag (DC3ImageType_GROUP,
			    DC3ImageType_ELEMENT);

		DC3CodeString *attribute =
			MakeCodeStringFromThreeStringValues(tag,
				value1,value2,value3);

		list.insert(attribute);
	}
	{
		// ConvolutionKernel

		char *str;

		switch (CT98_PreprocessReconType.toUS()) {
			case 0:		str="UNDEFINED";
					break;
			case 1:		str="BONE";
					break;
			case 2:		str="SOFTTISSUE";
					break;
			case 3:		str="QUICKSOFTTISSUE";
					break;
			default:	str="";
					break;
		}

		DC3Tag tag (DC3ConvolutionKernel_GROUP,
			    DC3ConvolutionKernel_ELEMENT);
		DC3ShortString *attribute =
			new DC3ShortString(tag,strlen(str),str);
		list.insert(attribute);
	}
	{
		// Rows

		DC3Tag tag (DC3Rows_GROUP,
			    DC3Rows_ELEMENT);

		Uint16 i=(CT98_FileType.toUS() == 2)	// Scout
			? CT98_ViewsPerScan.toUS()
			: CT98_ImageSize.toUS();

		DC3UnsignedShort *attribute =
			new DC3UnsignedShort(tag,2,&i);
		list.insert(attribute);
	}
	{
		// Columns

		DC3Tag tag (DC3Columns_GROUP,
			    DC3Columns_ELEMENT);

		Uint16 i=(CT98_FileType.toUS() == 2)	// Scout
			? CT98_DetectorsPerView.toUS()
			: CT98_ImageSize.toUS();

		DC3UnsignedShort *attribute =
			new DC3UnsignedShort(tag,2,&i);
		list.insert(attribute);
	}
