.TH DC3CONVERT 1 "03 February 1995" "DICOM PS3" "Vendor formats to dicom"
.SH NAME
dc3convert \- ACR/NEMA DICOM PS3 ... Vendor formats to dicom
.SH SYNOPSIS
.SS "GE 9800 CT ..."
.LP
\ 
.HP 10
.B ge98dump
.I inputfilename
.HP 10
.B ge98todc
[
.BI \-d " deletekeyword"
] ...
[
.BI \-r " replacekeyword values"
] ...
[
.BI \-m
]
[
.BI \-o " outputtransfersyntax"
]
[
.BI \-s " datestamp"
]
[
.B \-v
]
.I inputfilename
.I outputfilename
.SS "GE Genesis CT/MR ..."
.LP
\ 
.HP 10
.B gendump
[
.BI \-l " imgf|dat"
]
.I inputfilename
.HP 10
.B gentodc
[
.BI \-l " imgf|dat"
]
[
.BI \-d " deletekeyword"
] ...
[
.BI \-r " replacekeyword values"
] ...
[
.BI \-m
]
[
.BI \-o " outputtransfersyntax"
]
[
.BI \-s " datestamp"
]
[
.B \-v
]
.I inputfilename
.I outputfilename
.SS "GE Signa 3X/4X MR ..."
.LP
\ 
.HP 10
.B sgndump
.I inputfilename
.HP 10
.B sgntodc
[
.BI \-d " deletekeyword"
] ...
[
.BI \-r " replacekeyword values"
] ...
[
.BI \-m
]
[
.BI \-o " outputtransfersyntax"
]
[
.BI \-s " datestamp"
]
[
.B \-v
]
.I inputfilename
.I outputfilename
.SS "GE Sytec CT ..."
.LP
\ 
.HP 10
.B sytdump
.I inputfilename
.HP 10
.B syttodc
[
.BI \-d " deletekeyword"
] ...
[
.BI \-r " replacekeyword values"
] ...
[
.BI \-m
]
[
.BI \-o " outputtransfersyntax"
]
[
.BI \-s " datestamp"
]
[
.B \-v
]
.I inputfilename
.I outputfilename
.SS "Siemens Somatom CT ..."
.LP
\ 
.HP 10
.B somdump
.I inputfilename
.HP 10
.B somtodc
[
.BI \-d " deletekeyword"
] ...
[
.BI \-r " replacekeyword values"
] ...
[
.BI \-m
]
[
.BI \-o " outputtransfersyntax"
]
[
.BI \-s " datestamp"
]
[
.B \-v
]
.I inputfilename
.I outputfilename
.SH DESCRIPTION
.LP
This man page briefly describes the conversion programs available for creating 
.I DICOM
(Digital Imaging Communications in Medicine) version 3 offline files, as described in the standard published by 
.I ACR/NEMA 
(American College of Radiology and National Electrical Manufacturers Association) from proprietary vendor's formats, making every effort to maximize the amount of imformation extracted, and produce offline files that are complete DICOM objects. Programs to dump (describe) fully the contents of vendor's file are also provided. The common features and options are described here.
.LP
For more information about each specific conversion, see the individual man pages listed under the "See Also" section.
.LP
Described elsewhere are programs for manipulating DICOM offline files (see the man page dc3intro.1) as well as converting vendor's formats to primitive file types (see the man page dc3simple.1), utilities for extracting images from various vendor's proprietary archive formats (nine-track tape, etc.) (see the man page dc3archive.1),and various miscellaneous utilities related to manipulation of medical images (see the man page dc3misc.1).
.SS "GE 9800 CT ..."
.LP
\ 
.LP
.B ge98dump
reads the named GE 9800 input file and dumps its contents.
.LP
.B ge98todc
reads the named GE 9800 input file and converts it to a dicom output file.
.LP
.SS "GE Genesis CT/MR ..."
.LP
\ 
.LP
Note that the Genesis architecture is used on the GE High Speed Advantage CT and the Signa 5X revision MRI.
.LP
.B gendump
reads the named GE Genesis CT/MR input file and dumps its contents.
.LP
.B gentodc
reads the named GE Genesis CT/MR input file and converts it to a dicom output file.
.LP
.SS "GE Signa 3X/4X MR ..."
.LP
\ 
.LP
.B sgndump
reads the named GE Signa 3X/4X MR input file and dumps its contents.
.LP
.B sgntodc
reads the named GE Signa 3X/4X MR input file and converts it to a dicom output file.
.LP
.SS "GE Sytec CT ..."
.LP
\ 
.LP
.B sytdump
reads the named GE Sytec CT input file and dumps its contents.
.LP
.B syttodc
reads the named GE Sytec CT input file and converts it to a dicom output file.
.LP
.SS "Siemens Somatom CT ..."
.LP
\ 
.LP
Note that the more recent Siemens products, such as the Somatom Plus, use an ACR/NEMA 1 based SPI (Standard Product Interconnect) format that is readable with the DICOM 3 utilities, which are augmented to handle the SPI Private Groups. See dc3intro(1).
.LP
.B somdump
reads the named Siemens Somatom CT input file and dumps its contents.
.LP
.B somtodc
reads the named Siemens Somatom CT input file and converts it to a dicom output file.
.LP
.SH OPTIONS
Input and output file names must be specified for most utilities. Redirection from standard input or to standard output is generally not supported. The dump output and verbose output go to standard error.
.LP
Switch options must not be concatenated - they must have their own
leading hyphen. Keyword names are taken from the DICOM Standard data
dictionary, with spaces between words elided.
.LP
For input, if an explicit input transfer syntax is not specified, any valid DICOM 3 Part 10 metaheader present will be used, otherwise an attempt to guess the byte order and value representation will be made (skipping 128 bytes if necessary to allow Siemens SPI files to be read).
.LP
The default output transfer syntax is the Default Little Endian
transfer syntax, which may be overridden as required by specifying the
appropriate UID on the command line. A DICOM 3 Part 10 metaheader will only be written if the -m option is specified. The use of this option is mandatory for
full DICOM 3 compliance, but it is not the default in view of the history of various DICOM implementations and tools.
.LP
Group lengths and length to end are recalculated as necessary, even though no longer required by the standard, to maintain backward compatibility.
.PP
The basic switches (not all apply to all utilities) are:
.TP
.BI \-d " deletekeyword"
.LP
.RS
Delete attribute described by "keyword".
.RE
.TP
.BI \-r " replacekeyword values"
.LP
.RS
Replace (or insert if not there) the attribute described by "keyword. If the
attribute has a string value representation, then multiple values separated
by the standard DICOM backslash delimiter should be used. For integer
value representations multiple values separated by any single non-numeric
character will work.
.RE
.TP
.B \-m
.RS
Metaheader flag - write Part 10 style metaheader (mandatory for
full DICOM 3 compliance).
.RE
.TP
.BI \-o " outputtransfersyntax"
.TP
.BI \-s " datestamp"
.LP
.RS
Use the supplied value rather than the current date and time to create
unique identifiers (UIDs) when needed.
.RE
.TP
.B \-v
.RS
Verbose flag - describes the DICOM tags being read or generated.
.RE
.SH ENVIRONMENT
.LP
\ 
.SH EXAMPLES
.LP
\ 
.SH FILES
.LP
\ 
.SH SEE ALSO
.BR dc3archive(1) ,
.BR dc3convert(1) ,
.BR dc3intro(1) ,
.BR dc3intro(3) ,
.BR dc3intro(5) ,
.SH AUTHOR
Copyright (C) 1993,1994,1995. David A. Clunie. All rights reserved.
.SH BUGS
No support for deleting/replacing private groups/attributes.
.LP
Metaheader flag should probably be the default.
.LP
