static char *CopyrightIdentifier(void) { return "@(#)gendump.cc 0.12 95/09/18 Copyright (C) 1993,1994,1995. David A. Clunie. All rights reserved."; }

#ifdef __GNUG__
#include <builtin.h>
#endif
#include <math.h>
#include <string.h>

#include <fstream.h>
#include <strstream.h>
#include <iomanip.h>

#include "GetOpt.h"
#include "MainCmd.h"

#include "genptrsd.h"

GENESIS_headerlayout_type GENESIS_headerlayout;

void
do_dump(ifstream& instream);

int
main(int argc,char *argv[])
{
	CCOMMAND(argc,argv);

	char *	inname = 0;

	GENESIS_headerlayout=GENESIS_IMGF_layout;

	GetOpt getopt(argc,argv,"l:");
	int c;
	int err=0;
	while ((c=getopt()) != -1 && !err) {
		switch (c) {
			case 'l':	// layout type (imgf or dat)
				{
					char *type=getopt.optarg;
					switch (type[0]) {
						case 'i':
						case 'I':
							GENESIS_headerlayout=
							  GENESIS_IMGF_layout;
							break;
						case 'd':
						case 'D':
							GENESIS_headerlayout=
							  GENESIS_DAT_layout;
							break;
						case 'c':
						case 'C':
							GENESIS_headerlayout=
							  GENESIS_AWCT_layout;
							break;
						case 'm':
						case 'M':
							GENESIS_headerlayout=
							  GENESIS_AWMR_layout;
							break;
						default:
							cerr
							  << "Bad layout\n"
							  << flush;
							err=1;
					}
				}
				break;
			case '?':
			default:
				err=1;
		}
	}

	if (getopt.optind+1 == argc) {
		inname=argv[getopt.optind];
	}
	else err=1;

	if (err) {
		cerr << "Usage: " << argv[0] << " "
		     << "[-l imgf|dat|ctadvwin|mradvwin] "
		     << "infile\n"
		     << flush;
		return 1;
	}

	ifstream instream(inname,ios::in);
	if (!instream.rdbuf()->is_open()) {
		cerr << "Can't open <" << inname << "> for read\n" << flush;
		return 1;
	}

	do_dump(instream);

	return 0;
}

