.TH S15TODC 1 "03 February 1995" "Philips S15" "Gyroscan S15 extract images to DICOM"
.SH NAME
s15todc \- Philips Gyroscan S15 extract images to DICOM format
.SH SYNOPSIS
.HP 10
.B s15todc
.I series
.I outprefix
.SH DESCRIPTION
.LP
.B s15todc
extracts all the images from series.REC into a bunch of files named outprefix.echo.series.dc3, using the parameters in series.NMR to decide how many slices and echos and what the resolution is. Takes into account the weird ordering in the series.REC file (ie. first entry is 1 past mid-slice and echos are interleaved 1st echo 1st, then 2nd echo, etc.). Writes in DICOM 3 offline file format, doing its best to decipher as many fields as possible from PATIENT.DRC and series.NMR.
.SH OPTIONS
.LP
\ 
.SH ENVIRONMENT
.LP
\ 
.SH EXAMPLES
.LP
\n % s15todc 0401 images/0401
\n 
\n nslices=16 nechoes=2 resolution=256
\n firstslice=9 nentries=32
\n entry=0 slice=9 echo=1
\n entry=1 slice=9 echo=2
\n entry=2 slice=10 echo=1
\n entry=3 slice=10 echo=2
\n ...
.SH FILES
.LP
\ 
.SH SEE ALSO
.BR dc3archive(1) ,
.BR dc3convert(1) ,
.BR dc3intro(1) ,
.BR dc3intro(3) ,
.BR dc3intro(5) ,
.BR dc3misc(1) ,
.BR dc3simple(1) ,
.BR s15dunmr(1) ,
.BR s15ex9t(1) ,
.BR s15exall(1) ,
.BR s15exnmr(1) ,
.BR s15exrec(1) ,
.BR s15todc(1)
.SH AUTHOR
Copyright (C) 1993,1994,1995. David A. Clunie. All rights reserved.
.SH BUGS
Should probably be able to pass additional options, like transfer syntax and so on. Currently it writes a meteheader and default transfer syntax.

