.TH S15TORAW 1 "03 February 1995" "Philips S15" "Gyroscan S15 extract images to raw"
.SH NAME
s15toraw \- Philips Gyroscan S15 extract images to raw format
.SH SYNOPSIS
.HP 10
.B s15toraw
[
.B \-v
]
.I series.NMR
.I series.REC
.I prefix
.I suffix
.SH DESCRIPTION
.LP
.B s15toraw
extracts all the images from series.REC into a bunch of files named prefix.echo.series.suffix, using the parameters in series.NMR to decide how many slices and echos and what the resolution is. Takes into account the weird ordering in the series.REC file (ie. first entry is 1 past mid-slice and echos are interleaved 1st echo 1st, then 2nd echo, etc.). Writes in 2 byte word little-endian format.
.SH OPTIONS
The NMR file, REC file, prefix and suffix 
.I must
all be specified. The verbose output all goes to standard error.
.PP
Any of the following options must be specified:
.TP
.B \-v
.RS
Verbose description of progress.
.RE
.LP
\ 
.SH ENVIRONMENT
.LP
\ 
.SH EXAMPLES
.LP
\n % s15toraw -v 0201.NMR 0201.REC out wrw
\n Parsing NMR file
\n Reading REC file
\n         resolution=     256
\n         nslices=        18
\n         nechoes=        2
\n         firstslice=     10
\n         nentries=       36
\n Writing out.1.10.wrw
\n Writing out.2.10.wrw
\n Writing out.1.11.wrw
\n Writing out.2.11.wrw
\n Writing out.1.12.wrw
\n Writing out.2.12.wrw
\n Writing out.1.13.wrw
\n Writing out.2.13.wrw
\n Writing out.1.14.wrw
\n Writing out.2.14.wrw
\n Writing out.1.15.wrw
\n Writing out.2.15.wrw
\n Writing out.1.16.wrw
\n Writing out.2.16.wrw
\n Writing out.1.17.wrw
\n Writing out.2.17.wrw
\n Writing out.1.18.wrw
\n Writing out.2.18.wrw
\n Writing out.1.01.wrw
\n Writing out.2.01.wrw
\n Writing out.1.02.wrw
\n Writing out.2.02.wrw
\n Writing out.1.03.wrw
\n Writing out.2.03.wrw
\n Writing out.1.04.wrw
\n Writing out.2.04.wrw
\n Writing out.1.05.wrw
\n Writing out.2.05.wrw
\n Writing out.1.06.wrw
\n Writing out.2.06.wrw
\n Writing out.1.07.wrw
\n Writing out.2.07.wrw
\n Writing out.1.08.wrw
\n Writing out.2.08.wrw
\n Writing out.1.09.wrw
\n Writing out.2.09.wrw
.SH FILES
.LP
\ 
.SH SEE ALSO
.BR dc3archive(1) ,
.BR dc3convert(1) ,
.BR dc3intro(1) ,
.BR dc3intro(3) ,
.BR dc3intro(5) ,
.BR dc3misc(1) ,
.BR dc3simple(1) ,
.BR s15dump(1) ,
.BR s15ex9t(1) ,
.BR s15todc(1) ,
.BR s15topgm(1)
.SH AUTHOR
Copyright (C) 1993,1994,1995. David A. Clunie. All rights reserved.
.SH BUGS
Uses the first parameter of the scan_resolution to determine the image matrix size ... this seems to work, but will it always ?
