.TH DC3CP 1 "03 February 1995" "DICOM PS3" "DICOM PS3 - Copy dicom file"
.SH NAME
dc3cp \- ACR/NEMA DICOM PS3 ... Copy dicom file
.SH SYNOPSIS
.HP 10
.B dc3cp
[
.BI \-d " deletekeyword"
] ...
[
.BI \-r " replacekeyword values"
] ...
[
.BI \-m
]
[
.BI \-i " inputtransfersyntax"
]
[
.BI \-o " outputtransfersyntax"
]
[
.BI \-s " datestamp"
]
[
.B \-p
]
[
.B \-v
]
[
.B \-w
]
[
.B \-b
]
.I inputfilename
.I outputfilename
.SH DESCRIPTION
.LP
.B dc3cp
reads the named dicom input file and copies it a dicom output file. The
purpose of this utility is to:
.HP 10
.B 1.
Allow deletion, insertion or substitution of attributes with command line
options.
.HP
.B 2.
Convert between different transfer syntaxes.
.HP
.B 3.
Read old style ACR/NEMA files and scrub out undesirable or unrecognized
attributes, including private attributes, and insert mandatory DICOM 3
ones.
.LP
.SH OPTIONS
Input and output file names 
.I must
be specified. Redirection from standard input or to standard output are
not supported. The verbose output goes to standard error.
.PP
The basic switches are described in dc3intro(1). Options specific to this program are:
.TP
.B \-p
.RS
Remove private groups.
.RE
.SH ENVIRONMENT
.LP
\ 
.SH EXAMPLES
.LP
\n % dc3cp \-m \-v impact.spi test.dc3
\n ...
\n (000028,000010) US Rows    VR=<US> VL=<2> [100]
\n ...
\n 
\n % echo Make explicit big endian, with stamp & replacement
\n 
\n % dc3cp \-m \-v \-o 1.2.840.10008.1.2.2 \-s "9999" 
\n         \-r PatientSex F test.dc3 test.big
\n ************** Deletions ************
\n ************** Replacements ************
\n (000010,000040) CS PatientSex VR=<CS> VL=<2> <F> 
\n **************** Reading **************
\n ...
\n (000010,000040) CS PatientSex VR=<CS> VL=<2> <M > 
\n ...
\n (000028,000010) US Rows       VR=<US> VL=<2> [100]
\n ...
\n **************** Deleting **************
\n **************** Replacing **************
\n **************** Fixing **************
\n **************** Writing **************
\n ...
\n (000010,000040) CS PatientSex VR=<CS> VL=<2> <F> 
\n ...
\n (000028,000010) US Rows       VR=<US> VL=<2> [100]
\n ...
.SH FILES
.LP
\ 
.SH SEE ALSO
.BR dc3archive(1) ,
.BR dc3convert(1) ,
.BR dc3intro(1) ,
.BR dc3intro(3) ,
.BR dc3intro(5) ,
.BR dc3misc(1) ,
.BR dc3simple(1)
.SH AUTHOR
Copyright (C) 1993,1994,1995. David A. Clunie. All rights reserved.
.SH BUGS
