.TH DC3KEY 1 "03 February 1995" "DICOM PS3" "DICOM PS3 - Extract attributes by keyword"
.SH NAME
dc3key \- ACR/NEMA DICOM PS3 ... Extract attributes by keyword
.SH SYNOPSIS
.HP 10
.B dc3key
[
.BI \-k " keyword"
] ...
[
.BI \-i " inputtransfersyntax"
]
[
.B \-l
]
[
.B \-v
]
[
.B \-w
]
[
.B \-b
]
.I inputfilename
.SH DESCRIPTION
.LP
.B dc3key
reads the named dicom input file and extracts attributes by keyword and displays their values. The purpose of this utility is to extract attribute values for use in scripts to manipulate files based on their content.
.LP
.SH OPTIONS
Input file name 
.I must
be specified. Redirection from standard input is
not supported. The attribute values are output to standard out.
.PP
The basic switches are described in dc3intro(1). Switches specific to this utility are:
.TP
.BI \-k " keyword"
.LP
.RS
Extract the attribute described by "keyword".
.RE
.TP
.B \-l
.RS
Label flag - include the keyword name in the output.
.RE
.SH ENVIRONMENT
.LP
\ 
.SH EXAMPLES
.LP
\n 
\n % dc3key -k Manufacturer test.dc3
\n GENERAL ELECTRIC
\n 
\n % dc3key -l -k Manufacturer -k Modality test.dc3
\n Modality=MR
\n Manufacturer=GENERAL ELECTRIC
.SH FILES
.LP
\ 
.SH SEE ALSO
.BR dc3archive(1) ,
.BR dc3convert(1) ,
.BR dc3intro(1) ,
.BR dc3intro(3) ,
.BR dc3intro(5) ,
.BR dc3misc(1) ,
.BR dc3simple(1)
.SH AUTHOR
Copyright (C) 1993,1994,1995. David A. Clunie. All rights reserved.
.SH BUGS
No support for extracting private groups/attributes.
