.TH DC3TORAW 1 "03 February 1995" "DICOM PS3" "DICOM PS3 - Extract image to raw file"
.SH NAME
dc3toraw \- ACR/NEMA DICOM PS3 ... Extract image to raw file
.SH SYNOPSIS
.HP 10
.B dc3toraw
[
.BI \-i " inputtransfersyntax"
]
[
.BI \-o " outputtransfersyntax"
]
[
.B \-v
]
[
.B \-w
]
[
.B \-b
]
[
.B \-c
]
.I inputfilename
.I outputfilename
.SH DESCRIPTION
.LP
.B dc3toraw
reads the named dicom input file and extracts the image pixel data to the
specified raw output file. Either 8 or 16 bits per pixel will be written
as determined from the BitsAllocated and BitsStored attributes.
.LP
The only need for an output transfer
syntax to be specified is to determine the output byte order of 
16 bit words. The verbose option output will include such things as are
necessary to determine the size of the output file (Rows, Columns, etc.).
.LP
Some handy UIDs to know for transfer syntaxes include:
\n 
\n implicit vr little endian   1.2.840.10008.1.2
\n explicit vr little endian   1.2.840.10008.1.2.1
\n explicit vr big    endian   1.2.840.10008.1.2.2
\n 
.LP
.SH OPTIONS
Input and output file names 
.I must
be specified. Redirection from standard input or to standard output are
not supported. The dump output and verbose output go to standard error.
.PP
The basic switches are described in dc3intro(1). Switches specific to this utility are:
.TP
.B \-c
.RS
Convert flag - convert signed pixel representation to unsigned values.
.RE
.SH ENVIRONMENT
.LP
\ 
.SH EXAMPLES
.LP
\n % echo Making little endian
\n 
\n % dc3toraw \-v test.dc3 test.raw
\n 
\n % echo Making big endian
\n 
\n % dc3toraw \-v \-o 1.2.840.10008.1.2.2 test.dc3 test.raw
\n % echo Making unsigned raw from signed
\n 
\n % dc3toraw \-v \-c sytec.dc3 sytec.raw
\n 
.SH FILES
.LP
\ 
.SH SEE ALSO
.BR dc3archive(1) ,
.BR dc3convert(1) ,
.BR dc3intro(1) ,
.BR dc3intro(3) ,
.BR dc3intro(5) ,
.BR dc3misc(1) ,
.BR dc3simple(1)
.SH AUTHOR
Copyright (C) 1993,1994,1995. David A. Clunie. All rights reserved.
.SH BUGS
